#include "config.h"
#include "config-std.h"
#include "config-mem.h"
#include "jni.h"
#include "jtypes.h"
#include "errors.h"
#include "support.h"
#include "md.h"
#include "itypes.h"

typedef void void_void_f (void);

void
sysdepCallMethod (callMethodInfo * call)
{
  int *args;
  int argidx;
  /* How to make it work with optimization? */
  register int o0 asm ("%r26");
  register int o1 asm ("%r25");
  register int o2 asm ("%r24");
  register int o3 asm ("%r23");
  register int r0 asm ("%r28");
  register int r1 asm ("%r29");
  /* Should we use fr8 for float results? */
  register double f0 asm ("%fr4");
  /* Is it possible to get stack pointer without asm statement? */
asm ("ldo -36(%%r30),%0":"=r" (args));
  /* FIXME: we must make sure that stack has sufficient size
     for all arguments!!! Maybe __builtin_alloca ? */
  for (argidx = 0; argidx < call->nrargs; argidx++)
    switch (call->callsize[argidx])
      {
      case 1:
	args[-argidx] = call->args[argidx].i;
	break;
      case 2:
	{
	  args[-argidx] = (int) (call->args[argidx].j);
	  args[-argidx - 1] = call->args[argidx].i;
	  argidx++;
	}
      default:
	break;
      }
  /* How is this piece of memory (%r30-52 ... %r30-36) normally used? */
  o0 = args[0];
  o1 = args[-1];
  o2 = args[-2];
  o3 = args[-3];
  /* Find a better way without typedef */
  ((void_void_f *) (call->function)) ();
  switch (call->retsize)
    {
    case 1:
      if (call->rettype == 'F')
	call->ret->f = f0;
      else
	call->ret->i = r0;
      break;
    case 2:
      if (call->rettype == 'D')
	call->ret->d = f0;
      else
	{
	  call->ret->i = r0;
	  *(((int *) call->ret) + 1) = r1;
	}
      break;
    default:
      break;
    }
}
